## aspectc++ 1.2+svn20150823

=== Ag++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************


# PUMA root
PUMA    ?= ../Puma

# default target
TARGET  ?= linux-release

#AspectC++ source directory
AC_SRC_DIR := ../AspectC++

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# determine which Puma library to use: libMiniPuma is preferred
PUMA_LIBS := $(notdir $(wildcard $(PUMA)/lib/$(TARGET)/lib*Puma.a))
ifneq ($(filter libMiniPuma.a, $(PUMA_LIBS)),)
	PUMA_LIB := MiniPuma
else
	PUMA_LIB := Puma
endif

#CXX  := /usr/bin/g++-3.3
#CXX := ag++  -p. -p../aspects --Xcompiler
#CXX := ag++ -v3 -p. --Xcompiler

# compiler settings
ifeq ($(_TARGET),win32)
        CXXFLAGS += -I $(PUMA)/src/win32/regex
	EXT :=.exe
	RES := mingw32-windres
endif

CXXFLAGS += $(CPPFLAGS) -I$(PUMA)/extern -I$(PUMA)/include
ifneq ($(_TARGET),macosx)
	ifeq ($(SHARED),)
		LDFLAGS += -static
	endif

LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)

ifneq ($(SHARED),)
LDFLAGS += -Wl,-Bdynamic
endif

else
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)
endif

ifneq ($(PROFILING),)
	LDFLAGS += -lc_p -lm_p 
	CXXFLAGS += -pg
endif

# ******************************
# *       S O U R C E S        *
# ******************************

BINBASE := bin
BINDIR := $(BINBASE)/$(TARGET)
PROG := $(BINDIR)/ag++$(EXT)

CCSOURCES := $(wildcard *.cc) 

OBJECTBASE := ObjFiles
OBJECTDIR := $(OBJECTBASE)/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:%.cc=%.o))

DEPBASE := DepFiles
DEPDIR := $(DEPBASE)/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:%.cc=%.d))

ifeq ($(_TARGET),win32)
RCFILES := win-ag++.rc
OBJECTS += $(addprefix $(OBJECTDIR)/,$(RCFILES:%.rc=%.o))
DEPS += $(addprefix $(DEPDIR)/,$(RCFILES:%.rc=%.d))
endif


DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)



# ******************************
# *     T A R G E T S          *
# ******************************

all: showtarget $(AC_SRC_DIR)/$(PROG)

strip: $(AC_SRC_DIR)/$(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making Ag++ for TARGET=$(TARGET)"
	@echo "  AC++     = $(ACXX) $(ACXXFLAGS) <objects> "
	@echo "  Compiler = $(CXX) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"

help: showtarget
	@echo 
	@echo 
	@echo "Make:" 
	@echo "  help:          show this help"
	@echo "  all (default): compile, link and copy"
	@echo "  copy:          copy executable into AspectC++ bin folder"
	@echo "  test :         run tests"
	@echo "  test_<XX>:     run test number <XX>"
	@echo "  clean:         remove intermediate files of current TARGET"
	@echo "  distclean:     clean all generated files and directories"
	@echo "---"

clean: 
	@echo -n "CLEAN    "
	rm -rf $(PROG) core core.*  $(DIRS)

distclean:
	rm -rf $(DEPBASE) $(OBJECTBASE) $(BINBASE)
 

test:	all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests;./run_tests.sh

test_%: all
	@export TARGET=$(TARGET);export _TARGET=$(_TARGET);export EXT=$(EXT);cd tests; ./run_tests.sh $@


.PHONY: all clean distclean showtarget

# ******************************
# *       R U L E S            *
# ******************************

$(PROG): $(OBJECTS)
	@echo "LD        $@"
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $^ $(LDFLAGS)

$(AC_SRC_DIR)/$(PROG): $(PROG)
	@echo "COPY      $< to $@"
	@mkdir -p $(AC_SRC_DIR)/bin/$(TARGET)
	@cp $< $@

$(OBJECTDIR)/%.o : %.cc
	@echo "DEP       $(DEPDIR)/$(<:%.cc=%.d)."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) $< 
	@echo "CC        $@"
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CXXFLAGS) -c -o $@ $<

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo "DEP       $@."
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DEPDIR)/$(<:%.cc=%.d) -MF $(DEPDIR)/$(<:%.cc=%.d) -xc++ $< 
	@echo "RES       $@"
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CXXFLAGS)) $< $@
endif

ifeq (,$(findstring clean,$(MAKECMDGOALS)))
ifeq (,$(findstring help,$(MAKECMDGOALS)))
-include $(DEPS)
endif
endif

.SUFFIXES: .cc .o .h .rc .mk $(SUFFIXES)

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# AspectC++ supports alternative frontends: Puma or Clang
# It can be configured the 'make FRONTEND=...'. Default is Puma.
FRONTEND ?= Puma

# PUMA root
PUMA    ?= ../Puma

# LLVM config command
LLVMCONF ?= llvm-config

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

# libxml2 settings
ifeq ($(_TARGET),win32)
	LIBXML2_INC := `mingw32-xml2-config --cflags` 
	LIBXML2_LIB := `mingw32-xml2-config --libs`
	EXT=.exe
else
	LIBXML2_INC := `xml2-config --cflags` 
	LIBXML2_LIB := `xml2-config --libs` 
endif

# Check Clang version
ifeq ($(FRONTEND),Clang)
  ifeq ($(shell which $(LLVMCONF)),)
    $(error FRONTEND is 'Clang', but LLVMCONF ($(LLVMCONF)) is not found)
  endif
  LLVM_VERSION := $(shell $(LLVMCONF) --version)
  LLVM_SUPPORTED_VERSIONS := 3.4 3.6.2
  LLVM_SYMBOLS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
                  _ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
                  _ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
                  _ZN5clang4Sema25ActOnEndOfTranslationUnitEv \
                  _ZN5clang12Preprocessor3LexERNS_5TokenE
  LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
  ifneq ($(filter $(LLVM_SUPPORTED_VERSIONS), $(LLVM_VERSION)),)
    $(info Clang version $(LLVM_VERSION): Fine)
  else
    $(warning Warning: UNSUPPORTED Clang version $(LLVM_VERSION) used)
    LLVM_FOUND   := $(foreach SYM, $(LLVM_SYMBOLS), $(shell nm --defined-only $(LLVM_LIBDIR)/libclang*.a | grep -w -c $(SYM)))
    ifneq ($(words $(LLVM_SYMBOLS)),$(words $(filter 1, $(LLVM_FOUND))))
      $(error Incompatible Clang version '$(LLVM_VERSION)': Not all wrapped symbols defined!)
    endif
  endif
endif

# linker settings
ifneq ($(_TARGET),macosx)
ifeq ($(SHARED),)
  LDFLAGS += -static
endif
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma 
ifneq ($(SHARED),)
	LDFLAGS += #-Wl,-Bdynamic
endif
endif
else
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma
endif
endif

LDFLAGS += $(LIBXML2_LIB)
ifneq ($(FRONTEND),Puma)
ifneq ($(_TARGET),macosx)
  LDFLAGS += -lclangRewriteFrontend -lclangRewriteCore -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
  LDFLAGS += `$(LLVMCONF) --ldflags`
else
# Mac OS X is special, we patch the clang libraries below.
  LDFLAGS += libclangSema.o libclangLex.o -lclangRewriteFrontend -lclangRewriteCore -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangAnalysis -lclangEdit -lclangAST -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  LDFLAGS += `$(LLVMCONF) --ldflags`
endif
ifneq ($(LLVM_VERSION),3.4)
  LDFLAGS := $(patsubst -lclangRewriteCore, -lclangRewrite, $(LDFLAGS))
  LDFLAGS += `$(LLVMCONF) --system-libs` # in 3.6 ldflags doesn't contain the system libs anymore
endif
endif

# compiler settings
ifeq ($(_TARGET),win32)
        CPPFLAGS += -I $(PUMA)/src/win32/regex
	RES := mingw32-windres
	RCFILES := win-ac++.rc
endif

CPPFLAGS += -I$(PUMA)/extern -I$(PUMA)/include $(LIBXML2_INC)
ifeq ($(FRONTEND),Puma)
  CPPFLAGS += -DFRONTEND_PUMA
else
  CPPFLAGS += `$(LLVMCONF) --cppflags`
  CPPFLAGS += -DFRONTEND_CLANG
  CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header 
  CXXFLAGS += -std=c++11 # Clang uses C++11 features
endif

# profiling
ifneq ($(GPROF),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif

ifneq ($(PROFILING),)
	CPPFLAGS += -DPROFILING
endif

# use libacmodel
LDFLAGS  += -LACModel/lib/$(TARGET) -lacmodel 


# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

# sources; front-end specific files for the wrong frontend are filtered out
CCSOURCES := $(wildcard *.cc)
ifeq ($(FRONTEND),Puma)
CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
else
CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
endif

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
MAKE ?= make

# ac++ settings for tests
ACFLAGS := -k -v 9

ACEXAMPLES = coverage helloworld modules profiling singleton threads


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

all: libacmodel showtarget $(PROG)
#.NOTPARALLEL: all

strip: $(PROG)
	@$(STRIP) $<

showtarget:
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"


clean:  testclean exampleclean
	@echo Making it clean.
	@$(MAKE) -C ACModel clean
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

cleanall:	doxygen-clean clean

test: $(PROG)$(EXT) testall

example: $(PROG)$(EXT) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp

doxygen:
	@echo "Making AspectC++ documentation with doxygen"
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

doxygen-clean:
	@rm -rf doc/doxygen

.PHONY: all test clean cleanall example examplerun exampleclean \
        showtarget doxygen doxygen-clean libacmodel



# ******************************
# *       R U L E S            *
# ******************************




$(DIRS) :
	@mkdir -p $@

libacmodel :
	@$(MAKE) -C ACModel

$(PROG): $(OBJECTS) | libacmodel
# For clang on macosx we create relinked objects with the patched symbols.
ifneq ($(FRONTEND),Puma)
ifeq ($(_TARGET),macosx)
	@echo "Creating patched clang libraries ..."
	@$(LD) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
	  -alias __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ ___real__ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ -unexported_symbol __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
	  -alias __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj ___real__ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj -unexported_symbol __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
	  -alias __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE ___real__ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE -unexported_symbol __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
	  -alias __ZN5clang4Sema25ActOnEndOfTranslationUnitEv ___real__ZN5clang4Sema25ActOnEndOfTranslationUnitEv -unexported_symbol __ZN5clang4Sema25ActOnEndOfTranslationUnitEv
	@$(LD) -r `$(LLVMCONF) --libdir`/libclangLex.a -o libclangLex.o -all_load \
	  -alias __ZN5clang12Preprocessor3LexERNS_5TokenE ___real__ZN5clang12Preprocessor3LexERNS_5TokenE -unexported_symbol __ZN5clang12Preprocessor3LexERNS_5TokenE
endif
endif
	@echo "Linking $@."
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)


$(OBJECTDIR)/%.o : %.cc
	@echo Making dependency file $(DEPDIR)/$(<:%.cc=%.d).
	@mkdir -p $(DEPDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -MM -MP -MT $(OBJECTDIR)/$(<:%.cc=%.o) -MT $(DEPDIR)/$(<:%.cc=%.d) $< > $(DEPDIR)/$(<:%.cc=%.d)
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR)
	@$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

ifeq ($(_TARGET),win32)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../$<-out; g++ -o $< *.cc -lpthread

%.example_run:	%.example_make
	@echo ""
	@echo ---- Running $* ----
	@cd examples/$*-out; `find . -type f -perm -700`

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

=== Puma/Makefile ===
#-------------------------------------------------
# variables 
#-------------------------------------------------

ROOT    ?= $(shell pwd)
TARGET  ?= linux-release
AC      ?= ac++
PREFIX  ?= /usr/local 

include vars.mk
include files.mk

ifneq ($(MINI),)
LIBNAME := libMiniPuma
else
LIBNAME := libPuma
endif

LIBDIR  := $(ROOT)/lib/$(TARGET)
GENDIR  := $(ROOT)/gen-$(RELEASE)

INCDIR  := $(ROOT)/include
EXTDIR  := $(ROOT)/extern
OBJDIR  := $(GENDIR)/obj-$(_TARGET)
STEP1   := $(GENDIR)/step1
STEP2   := $(GENDIR)/step2

CONFIG  := $(GENDIR)/puma.cfg
ACNEWREPO ?= $(GENDIR)/acpp.repo

# exported variables
export GENDIR INCDIR EXTDIR LIBNAME LIBDIR OBJDIR STEP1 STEP2
export ROOT TARGET AC DONTWEAVE CONFIG ACNEWREPO
export LEMSOURCES SOURCES CSOURCES ASPECTS 

# suppress reporting directory changes
MAKE := $(MAKE) --no-print-directory

#-------------------------------------------------
# rules
#-------------------------------------------------

all: showinfo src

weave: showinfo src

compile: showinfo src

showinfo:
	@echo 
	@echo "---"
	@echo "Making PUMA for TARGET=$(TARGET)"
	@echo "  Extensions = $(EXTENSIONS)"
	@echo "---"
	@echo 

tools:
	@cd $(ROOT)/tools && $(MAKE)

src: tools
	@cd $(ROOT)/src && $(MAKE) $(MAKECMDGOALS)

examples: tools
	@$(MAKE) -C $(ROOT)/src
	@cd $(ROOT)/examples && $(MAKE)

doc:
	@echo "Generating Puma reference manual..."
	@doxygen doc/RefMan/doxygen.conf && echo "=> see doc/RefMan/html/index.html"

install: src
	@echo "Installing library and headers..."
	@mkdir -p $(PREFIX)/lib
	@cp -pv $(LIBDIR)/$(LIBNAME).* $(PREFIX)/lib
	@mkdir -p $(PREFIX)/include/Puma
	@cp -pv $(INCDIR)/Puma/*.*h $(PREFIX)/include/Puma

uninstall: 
	@echo "Uninstalling library and headers..."
	@rm -fv $(PREFIX)/lib/$(LIBNAME).*
	@rm -rfv $(PREFIX)/include/Puma

clean: tools-clean
	@cd $(ROOT)/src && $(MAKE) clean

tools-clean:
	@cd $(ROOT)/tools && $(MAKE) -s clean

examples-clean:
	@cd $(ROOT)/examples && $(MAKE) -s clean

docs-clean:
	@echo "Making docs clean..."
	@rm -rf $(ROOT)/doc/RefMan/html

cleanall: test-clean examples-clean tools-clean docs-clean
	@echo "Making completely clean..."
	@rm -rf $(ROOT)/lib
	@rm -rf $(ROOT)/gen-*

distclean: clean examples-clean docs-clean
	@cd $(ROOT)/src && $(MAKE) distclean

libclean:
	@echo "Removing library and object files..."
	@rm -f $(LIBDIR)/$(LIBNAME).*
	@rm -rf $(OBJDIR)
	@rm -rf $(STEP2)/dep

test: test-all

test-%:
	@echo "Making tests $*..."
	@$(MAKE) -C tests -s $*

#-------------------------------------------------
# targets
#-------------------------------------------------

.PHONY: all tools src install examples distclean cleanall \
clean tools-clean examples-clean libclean weave compile uninstall doc

=== AspectC++/tests/Makefile ===
ifeq ($(REGRESSIONTEST),1)
MAKELEVEL := 1
endif

ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the ApectC++ source tree instead)
endif

SHELL=/bin/bash

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp STLString \
	  CFlowCycle Bug368 Bug179 RightlessCalls Bug477 \
	  IntroInBase Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
          MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
	  Bug549 Bug552 Bug554 DefaultArgs

ifeq ($(FRONTEND),Clang)
ACTESTS += DataFlowAnalysis
ACTESTS += CallBuiltinOperator
ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
           SimpleRefAdvice \
           Bug-Typenames DefaultArgs2
endif

# disabled: UnsizedArray
# to be removed: NonInlineIntroInclude
# (uses deprecated introduction syntax massively)

ACMSGTESTS := RepoInvalid RepoVersion

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

# ***** The following is only used for the Akut testsystem (REGRESSIONTEST == 1) *****
# ====================================================================================
ifeq ($(REGRESSIONTEST),1)

define do_test_start
    @COUNT=0;PASS=0;FAIL=0;
endef

define do_test_weave
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(1)/feature.out; \
	exec 2> $(1)/feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cat $(1)/feature.err >> $(1)/feature.out; \
	rm $(1)/feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	diff $(1)/feature.out $(1)/feature.ref; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_run
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $(1) diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_end
	echo -n "---EXECUTIVE SUMMARY: " ;\
	if [ $$FAIL -eq $$COUNT ]; then\
		echo FAIL \(all tests failed\) ;\
	elif [ $$FAIL -gt 0 ]; then \
		echo PARTLY \($$(( $$PASS * 100 / $$COUNT ))% tests passed as expected\); \
	else \
		echo PASS \(all tests passed\) ;\
	fi ;\
	echo ---START SUMMARY; \
	echo $$COUNT tests in this testcase; \
	echo $$PASS tests passed as expected; \
	echo $$FAIL tests did not pass as expected; \
	echo $$FAIL expected to pass but failed; \
	echo 0 expected to fail but passed; \
	echo ---END SUMMARY
endef

regression_test:
	$(call do_test_start) \
	$(foreach T, $(ACRUN), $(call do_test_run, $(T))) \
	$(foreach T, $(ACNORUN), $(call do_test_weave, $(T))) \
	$(call do_test_end)

endif

# ================================================================================
# ***** The above is only used for the Akut testsystem (REGRESSIONTEST == 1) *****


all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 fi;\
	 rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE)

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cat $</feature.err >> $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	diff $</feature.out $</feature.ref; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== AspectC++/tests/CompoundGetSetAdvice/Makefile ===
ACFLAGS ?= --builtin_operators --apiext_entity --data_joinpoints
include ../Makefile.generic

=== AspectC++/tests/FunctionEntity/Makefile ===
ACFLAGS ?= --apiext_entity
include ../Makefile.generic

=== debian/changelog ===
aspectc++ (1:1.2+svn20150823-1) unstable; urgency=medium

  * New upstream snapshot
  * Compiles with GCC-5, Closes: #777781
  * Bump standard version, no changes needed
  * This package is now maintained on git.debian.org

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 23 Aug 2015 22:04:29 -0400

=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man, zlib1g-dev
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 3.9.6
Homepage: http://www.aspectc.org
Vcs-Git: git://anonscm.debian.org/collab-maint/aspectc++.git

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to faciliate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to faciliate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# disable parallelism inside this makefile (but not submakes)
.NOTPARALLEL:

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

# workaround for bug #701244 - aspectc++ supports __int128 by default
# only when woven on 64bits, which the upstream provided sources don't.
AC_OPTFLAGS = --gnu-int128
export AC_OPTFLAGS

# we seem to have locking issues on kFreeBSD. force single threaded
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
NUMJOBS := 1
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS := -Wall -O0 -g
else
	CFLAGS := -Wall -O2 -g
endif
export CFLAGS
PUMA_CONFIG=$(CURDIR)/puma.config

test-builds: build-arch-stamp
	Ag++/bin/linux-release/ag++ --gen_config
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
	$(MAKE) -C Ag++/      SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
endif

build: build-arch build-indep

build-arch: build-arch-stamp test-builds
build-arch-stamp:
	dh_testdir
	# save a copy of Puma that will be woven later
	cp -r Puma Puma.copy
	$(MAKE) -C Puma/               -j$(NUMJOBS) compile
	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all
	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
	# ok, now we have both an ac++ binary and ag++ binary
	# now let's weave Puma again in the copy
	$(MAKE) -C Puma.copy clean
	$(MAKE) -C Puma.copy all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
	# let's clean and compile ac++ and ag++ again with new Puma
	$(MAKE) -C AspectC++ clean
	$(MAKE) -C Ag++      clean
	$(MAKE) -C AspectC++ SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
	$(MAKE) -C Ag++      SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all

	# build manpages:
	docbook-to-man debian/ac++.1.sgml > ac++.1
	docbook-to-man debian/ag++.1.sgml > ag++.1
	# mark timestamp
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	$(MAKE) -C Puma doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean build-*stamp binary-*stamp puma.config
	# cleaning up source directories:
	$(MAKE) -s -C Puma libclean
	$(MAKE) -s -C Puma tools-clean
	$(MAKE) -s -C Puma docs-clean
	$(MAKE) -s -C Puma examples-clean
	$(MAKE) -s -C AspectC++ clean
	$(MAKE) -s -C Ag++ clean
	# remove leftovers from Upstream Makefiles
	rm -rf AspectC++/tests/RepoVersion/repo.use
	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
	rm -rf AspectC++/tests/*/feature.out
	# remove generated manpages:
	rm -f ac++.1 ag++.1
	rm -rf AspectC++/bin
	rm -rf Puma.copy/
	# standard cleaning:
	dh_clean

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installchangelogs
	dh_installdocs -p libpuma-doc Puma/doc/RefMan/html
	dh_installexamples -p libpuma-doc Puma/examples/*
	dh_compress -X.cc -X.map
	dh_fixperms
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installchangelogs
	dh_installdocs
	dh_install
	dh_installexamples -p aspectc++ AspectC++/examples/*
	find debian/aspectc++ -name Makefile -exec rm -v {} +
	find debian/libpuma-doc -name Makefile -exec rm -v {} +
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary

## aspectc++ 2.0+svn20160329

=== AspectC++/Makefile ===
--- 
+++ 
@@ -3,8 +3,8 @@
 # ******************************
 
 # AspectC++ supports alternative frontends: Puma or Clang
-# It can be configured the 'make FRONTEND=...'. Default is Puma.
-FRONTEND ?= Puma
+# It can be configured the 'make FRONTEND=...'. Default is Clang.
+export FRONTEND ?= Clang
 
 # PUMA root
 PUMA    ?= ../Puma
@@ -19,42 +19,45 @@
 # => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
 include $(PUMA)/vars.mk
 
+# check whether we compile for Windows: TARGET-Variable starts with 'win'
+ifneq ($(filter win%,$(TARGET)),)
+	WIN := yes
+	EXT := .exe
+endif
+
 # libxml2 settings
-ifeq ($(_TARGET),win32)
-	LIBXML2_INC := `mingw32-xml2-config --cflags` 
-	LIBXML2_LIB := `mingw32-xml2-config --libs`
-	EXT=.exe
-else
-	LIBXML2_INC := `xml2-config --cflags` 
-	LIBXML2_LIB := `xml2-config --libs` 
-endif
+LIBXML2_INC := `xml2-config --cflags` 
+LIBXML2_LIB := `xml2-config --libs` 
 
 # Check Clang version
-ifeq ($(FRONTEND),Clang)
-  ifeq ($(shell which $(LLVMCONF)),)
-    $(error FRONTEND is 'Clang', but LLVMCONF ($(LLVMCONF)) is not found)
-  endif
-  LLVM_VERSION := $(shell $(LLVMCONF) --version)
-  LLVM_SUPPORTED_VERSIONS := 3.4 3.6.2
-  LLVM_SYMBOLS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
-                  _ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
-                  _ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
-                  _ZN5clang4Sema25ActOnEndOfTranslationUnitEv \
-                  _ZN5clang12Preprocessor3LexERNS_5TokenE
-  LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
-  ifneq ($(filter $(LLVM_SUPPORTED_VERSIONS), $(LLVM_VERSION)),)
-    $(info Clang version $(LLVM_VERSION): Fine)
-  else
-    $(warning Warning: UNSUPPORTED Clang version $(LLVM_VERSION) used)
-    LLVM_FOUND   := $(foreach SYM, $(LLVM_SYMBOLS), $(shell nm --defined-only $(LLVM_LIBDIR)/libclang*.a | grep -w -c $(SYM)))
-    ifneq ($(words $(LLVM_SYMBOLS)),$(words $(filter 1, $(LLVM_FOUND))))
-      $(error Incompatible Clang version '$(LLVM_VERSION)': Not all wrapped symbols defined!)
+ifneq ($(MAKECMDGOALS),clean)
+  ifeq ($(FRONTEND),Clang)
+    ifeq ($(shell which $(LLVMCONF)),)
+      $(error FRONTEND is 'Clang', but LLVMCONF ($(LLVMCONF)) is not found)
+    endif
+    LLVM_VERSION := $(shell $(LLVMCONF) --version)
+    LLVM_SUPPORTED_VERSIONS := 3.4 3.4svn 3.4.2 3.6.2 3.7.1
+    LLVM_SYMBOLS := _ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
+                    _ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
+                    _ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
+                    _ZN5clang4Sema25ActOnEndOfTranslationUnitEv \
+                    _ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE \
+                    _ZN5clang12Preprocessor3LexERNS_5TokenE
+    LLVM_LIBDIR  := $(shell $(LLVMCONF) --libdir)
+    ifneq ($(filter $(LLVM_SUPPORTED_VERSIONS), $(LLVM_VERSION)),)
+      $(info Clang version $(LLVM_VERSION): Fine)
+    else
+      $(warning Warning: UNSUPPORTED Clang version $(LLVM_VERSION) used)
+      LLVM_FOUND   := $(foreach SYM, $(LLVM_SYMBOLS), $(shell nm --defined-only $(LLVM_LIBDIR)/libclang*.a | grep -w -c $(SYM)))
+      ifneq ($(words $(LLVM_SYMBOLS)),$(words $(filter 1, $(LLVM_FOUND))))
+        $(error Incompatible Clang version '$(LLVM_VERSION)': Not all wrapped symbols defined!)
+      endif
     endif
   endif
 endif
 
 # linker settings
-ifneq ($(_TARGET),macosx)
+ifneq ($(_TARGET),macosx_x86_64)
 ifeq ($(SHARED),)
   LDFLAGS += -static
 endif
@@ -79,7 +82,7 @@
 
 LDFLAGS += $(LIBXML2_LIB)
 ifneq ($(FRONTEND),Puma)
-ifneq ($(_TARGET),macosx)
+ifneq ($(_TARGET),macosx_x86_64)
   LDFLAGS += -lclangRewriteFrontend -lclangRewriteCore -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
   LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
   LDFLAGS += `$(LLVMCONF) --ldflags`
@@ -89,15 +92,18 @@
   LDFLAGS += `$(LLVMCONF) --ldflags`
 endif
 ifneq ($(LLVM_VERSION),3.4)
+ifneq ($(LLVM_VERSION),3.4svn)
+ifneq ($(LLVM_VERSION),3.4.2)
   LDFLAGS := $(patsubst -lclangRewriteCore, -lclangRewrite, $(LDFLAGS))
   LDFLAGS += `$(LLVMCONF) --system-libs` # in 3.6 ldflags doesn't contain the system libs anymore
 endif
 endif
+endif
+endif
 
 # compiler settings
-ifeq ($(_TARGET),win32)
-        CPPFLAGS += -I $(PUMA)/src/win32/regex
-	RES := mingw32-windres
+ifeq ($(WIN),yes)
+	RES := windres
 	RCFILES := win-ac++.rc
 endif
 
@@ -105,10 +111,20 @@
 ifeq ($(FRONTEND),Puma)
   CPPFLAGS += -DFRONTEND_PUMA
 else
-  CPPFLAGS += `$(LLVMCONF) --cppflags`
+  FILTEROUT :=
+ifeq ($(RELEASE),debug)
+  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
+  FILTEROUT := -DNDEBUG
+endif
+  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
+  ifeq ($(WIN),yes)
+    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
+    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
+  endif
+  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
   CPPFLAGS += -DFRONTEND_CLANG
   CXXFLAGS += -fno-rtti -Wno-strict-aliasing # hide annoying warning in Clang header 
-  CXXFLAGS += -std=c++11 # Clang uses C++11 features
+  CXXFLAGS += -std=gnu++11 # Clang uses C++11 features; "c++11" does not work -> WIN32 not defined on Windows!
 endif
 
 # profiling
@@ -228,14 +244,15 @@
 	@$(MAKE) -C ACModel
 
 $(PROG): $(OBJECTS) | libacmodel
-# For clang on macosx we create relinked objects with the patched symbols.
+# For clang on macosx_x86_64 we create relinked objects with the patched symbols.
 ifneq ($(FRONTEND),Puma)
-ifeq ($(_TARGET),macosx)
+ifeq ($(_TARGET),macosx_x86_64)
 	@echo "Creating patched clang libraries ..."
 	@$(LD) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
 	  -alias __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ ___real__ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ -unexported_symbol __ZN5clang4Sema31ActOnStartCXXMemberDeclarationsEPNS_5ScopeEPNS_4DeclENS_14SourceLocationEbS5_ \
 	  -alias __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj ___real__ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj -unexported_symbol __ZN5clang4Sema19ActOnBaseSpecifiersEPNS_4DeclEPPNS_16CXXBaseSpecifierEj \
 	  -alias __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE ___real__ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE -unexported_symbol __ZN5clang4Sema33ActOnFinishCXXMemberSpecificationEPNS_5ScopeENS_14SourceLocationEPNS_4DeclES3_S3_PNS_13AttributeListE \
+          -alias __ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE ___real__ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE -unexported_symbol __ZN5clang4Sema19canSkipFunctionBodyEPNS_4DeclE \
 	  -alias __ZN5clang4Sema25ActOnEndOfTranslationUnitEv ___real__ZN5clang4Sema25ActOnEndOfTranslationUnitEv -unexported_symbol __ZN5clang4Sema25ActOnEndOfTranslationUnitEv
 	@$(LD) -r `$(LLVMCONF) --libdir`/libclangLex.a -o libclangLex.o -all_load \
 	  -alias __ZN5clang12Preprocessor3LexERNS_5TokenE ___real__ZN5clang12Preprocessor3LexERNS_5TokenE -unexported_symbol __ZN5clang12Preprocessor3LexERNS_5TokenE
@@ -256,7 +273,7 @@
 
 # -Wold-style-cast to find classic C casts "a = (A*)b;"
 
-ifeq ($(_TARGET),win32)
+ifeq ($(WIN),yes)
 $(OBJECTDIR)/%.o : %.rc
 	@echo Compiling Windows resource file
 	@mkdir -p $(OBJECTDIR)

=== AspectC++/tests/Makefile ===
--- 
+++ 
@@ -5,10 +5,11 @@
 ifeq ($(MAKELEVEL),0)
 $(error Sorry, this makefile is not intended to be \
 used directly. Please use the makefile in the toplevel \
-directory of the ApectC++ source tree instead)
+directory of the AspectC++ source tree instead)
 endif
 
 SHELL=/bin/bash
+DIFF=diff --strip-trailing-cr
 
 ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
           Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
@@ -26,21 +27,26 @@
 	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
           MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
 	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
-	  Bug549 Bug552 Bug554 DefaultArgs
+	  MemberPointCut MatchScopeWithin \
+	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
+	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
+          VirtualPointcuts
 
 ifeq ($(FRONTEND),Clang)
 ACTESTS += DataFlowAnalysis
-ACTESTS += CallBuiltinOperator
+ACTESTS += CallBuiltinOperator MemberPointCut2
 ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
-           SimpleRefAdvice \
-           Bug-Typenames DefaultArgs2
+           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
+           ArrayAccessAdvice MatchScope GetBaseDerived \
+           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
+           Bug567 Bug568 Bug548 Bug589 Bug594
 endif
 
 # disabled: UnsizedArray
 # to be removed: NonInlineIntroInclude
 # (uses deprecated introduction syntax massively)
 
-ACMSGTESTS := RepoInvalid RepoVersion
+ACMSGTESTS := RepoInvalid RepoVersion Bug570
 
 ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))
 
@@ -69,13 +75,13 @@
 	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
-	cat $(1)/feature.err >> $(1)/feature.out; \
+	cp $(1)/feature.err $(1)/feature.out; \
 	rm $(1)/feature.err; \
 	exec 6>&1; \
 	exec 7>&2; \
 	exec > $(STDOUT_FILE); \
 	exec 2> $(STDERR_FILE); \
-	diff $(1)/feature.out $(1)/feature.ref; \
+	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
 	RET=$$?; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
@@ -180,13 +186,13 @@
 	$(MAKE) -s EXT="$(EXT)" -C $< ; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
-	cat $</feature.err >> $</feature.out; \
+	cp $</feature.err $</feature.out; \
 	rm $</feature.err; \
 	exec 6>&1; \
 	exec 7>&2; \
 	exec > $(STDOUT_FILE); \
 	exec 2> $(STDERR_FILE); \
-	diff $</feature.out $</feature.ref; \
+	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
 	RET=$$?; \
 	exec 1>&6 6>&-; \
 	exec 2>&7 7>&-; \
@@ -244,6 +250,7 @@
 	$(MAKE) -s EXT="$(EXT)" -C $< ref; 
 
 %.run:	%
+	@echo Making and running test '$<'
 	cd $< && $(MAKE) run
 
 %.clean: %

=== debian/changelog ===
aspectc++ (1:2.0+svn20160329-1~bpo8.0) jessie-backports; urgency=medium

  * build against libclang 3.4

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 30 May 2016 20:13:57 -0400

aspectc++ (1:2.0+svn20160329-1) unstable; urgency=medium

  * Imported Upstream version 2.0+svn20160329

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 28 Mar 2016 23:26:18 -0400

aspectc++ (1:2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 04 Mar 2016 09:36:24 -0500

aspectc++ (1:2.0-1) experimental; urgency=medium

  * Imported Upstream version 2.0
  * Bump standard version, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Feb 2016 10:27:33 -0500

aspectc++ (1:1.2+svn20151025-1) unstable; urgency=medium

  * New upstream version
  * Enable LLVM support, Closes: #754697

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 24 Aug 2015 20:42:29 -0400

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Reinhard Tartler <siretart@tauware.de>
-Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man, zlib1g-dev
+Build-Depends: debhelper (>= 7.0.0), libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-3.4-dev, libclang-3.4-dev
 Build-Depends-Indep: doxygen, graphviz, gsfonts
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://www.aspectc.org
 Vcs-Git: git://anonscm.debian.org/collab-maint/aspectc++.git

=== debian/rules ===
--- 
+++ 
@@ -40,7 +40,7 @@
 test-builds: build-arch-stamp
 	Ag++/bin/linux-release/ag++ --gen_config
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
+	$(MAKE) -C AspectC++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4 test
 	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
 	$(MAKE) -C Ag++/      SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test
 endif
@@ -50,21 +50,15 @@
 build-arch: build-arch-stamp test-builds
 build-arch-stamp:
 	dh_testdir
-	# save a copy of Puma that will be woven later
-	cp -r Puma Puma.copy
-	$(MAKE) -C Puma/               -j$(NUMJOBS) compile
-	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all
+	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
+	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4
 	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
-	# ok, now we have both an ac++ binary and ag++ binary
-	# now let's weave Puma again in the copy
-	$(MAKE) -C Puma.copy clean
-	$(MAKE) -C Puma.copy all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
-	# let's clean and compile ac++ and ag++ again with new Puma
-	$(MAKE) -C AspectC++ clean
-	$(MAKE) -C Ag++      clean
-	$(MAKE) -C AspectC++ SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
-	$(MAKE) -C Ag++      SHARED=1 Puma=$(CURDIR)/Puma.copy -j$(NUMJOBS) all
-
+	# ok, now we have both an ac++ binary and ag++ binary now let's
+	# weave Puma again in the copy
+	$(MAKE) -C Puma clean
+	$(MAKE) -C Puma all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
+	# FIXME: The testsuite seems to ignore failures
+	$(MAKE) -C AspectC++ examples test FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1
 	# build manpages:
 	docbook-to-man debian/ac++.1.sgml > ac++.1
 	docbook-to-man debian/ag++.1.sgml > ag++.1
@@ -82,17 +76,18 @@
 	dh_testroot
 	dh_clean build-*stamp binary-*stamp puma.config
 	# cleaning up source directories:
-	$(MAKE) -s -C Puma libclean
-	$(MAKE) -s -C Puma tools-clean
-	$(MAKE) -s -C Puma docs-clean
-	$(MAKE) -s -C Puma examples-clean
-	$(MAKE) -s -C AspectC++ clean
-	$(MAKE) -s -C Ag++ clean
+	$(MAKE) -s -C Puma cleanall
+	# The clang frontend adds additional tests that need cleaning
+	# so far, no tests are excluded by using the Clang frontend
+	-$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-3.4
+	-$(MAKE) -s -C Ag++ clean
 	# remove leftovers from Upstream Makefiles
+	rm -rf Puma/include
 	rm -rf AspectC++/tests/RepoVersion/repo.use
 	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
 	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
 	rm -rf AspectC++/tests/*/feature.out
+	rm -rf AspectC++/tests/RepoVersion/feature.fil
 	# remove generated manpages:
 	rm -f ac++.1 ag++.1
 	rm -rf AspectC++/bin
